<template>
  <div
    class="fr-input-group"
    :class="{
      'fr-input-group--error': error,
      'fr-input-group--disabled': readonly
    }"
  >
    <label
      v-if="!noLabel"
      class="fr-label"
      :for="name"
    >
      {{ label }}
    </label>
    <div class="fr-input-wrap">
      <input
        :id="name"
        ref="input"
        v-model="modelValue"
        class="fr-input"
        :class="{ 'fr-input--error': error }"
        :name="name"
        placeholder="0.00"
        type="text"
        pattern="[0-9]\d*(\.\d+)?"
        :aria-describedby="ariaDescribedby"
        :aria-labelledby="labelledBy"
        :readonly="readonly"
        @keypress="onKeypress"
        @input="onValidate"
        @invalid="onValidate"
        @change="onChange"
      />
    </div>
    <div
      v-if="error"
      :id="errorId"
      class="fr-messages-group"
      aria-live="assertive"
    >
      <p class="fr-message fr-message--error">
        {{ error }}
      </p>
    </div>
  </div>
</template>

<script setup>
  const props = defineProps({
    label: { type: String, required: true },
    noLabel: { type: Boolean, default: false },
    labelledBy: { type: String, default: undefined },
    name: { type: String, required: true },
    value: { type: [String, Number], default: '' },
    readonly: { type: Boolean, default: false }
  })

  const emit = defineEmits(['changeValue'])

  const error = ref('')

  // This model is only used to prevent input value from being replace by initial value when custom error state changes
  const modelValue = ref(props.value)

  const errorId = computed(() => `${props.name}-error-desc-error`)
  const ariaDescribedby = computed(() =>
    props.error ? errorId.value : undefined
  )

  watch(
    () => props.value,
    value => (modelValue.value = value)
  )

  function onKeypress(e) {
    const ALLOWED_KEYS = [
      8, // Backspace
      9, // Tab
      13, // Enter
      27, // Escape
      33, // Pgup
      34, // Pgdown
      35, // End
      36, // Home
      37, // ArrowLeft
      38, // ArrowUp
      39, // ArrowRight
      40, // ArrowDown
      44, // Coma
      46, // Delete
      ...Array.from({ length: 58 - 48 }, (_, i) => 48 + i) // Numbers
    ]
    if (!ALLOWED_KEYS.includes(e.keyCode)) {
      e.preventDefault()
    }
  }

  function onChange({ target }) {
    emit('changeValue', target.value)
    onValidate({ target })
  }

  function onValidate({ target }) {
    error.value = target.validationMessage
  }
</script>

<style lang="scss" scoped>
  .fr-input-wrap::before {
    bottom: 0.75rem;
    margin: auto;
    pointer-events: none;
    position: absolute;
    right: 0.75rem;
    top: 0.75rem;
    content: '€';
    line-height: 1rem;
  }

  .fr-input {
    text-align: right;
    padding-right: 25px;
  }

  .fr-input-group--disabled .fr-input-wrap::before {
    color: var(--text-disabled-grey);
  }
</style>
